%Programme tudiant la recouvrabilit d'un capteur
format short 
%declaration of the state vector x
syms X G Co A
x=[X;G;Co;A];
%declaration of the input
syms F Gin N
u=[F;Gin;N];
%declaration of parameters
syms V 
%dclaration des constantes 
alpha=323;
N0=0.92;
Coo=1;   
ks=0.01;
ka=0.05;   
qmc=0.06;
qa_max=0.20;
qg_crit=0.63;
qg_max=1;
qo_max=0.35;
Yfexg=0.15;
Yoxxg=0.51;
Yxa=0.40;
Yom=1.07;
Yog=0.50;
Yoa=0.55;
Yag=0.55;
%dclaration des relations gnarales
Kla=alpha*(N-N0);
qg=qg_max*G/(G+ks);
%dclaration des relations propres au mode I Cas 1
disp('Mode I Cas 1');
qm=qmc;
qacpot=A*qa_max/(A+ka);
qac=qacpot;
mu=(qg-qm)*Yoxxg+qac*Yxa;
qo=(qg-qm)*Yog+qm*Yom+qac*Yoa;
qap=0;
qa=qap-qac; 
f=[ -F*X/V+mu*X;
    F*Gin/V-F*G/V-qg*X;
    -F*Co/V+Kla*(Coo-Co)-qo*X;
    -F*A/V+qa*X 
]; 
c=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
h=c*x; 
%observability mesurement
deriv=jacobian(h,x);
Lie1=mtimes(deriv,f);
deriv1=jacobian(Lie1,x);
Lie2=mtimes(deriv1,f);
deriv2=jacobian(Lie2,x);
Lie3=mtimes(deriv2,f);
deriv3=jacobian(Lie3,x); 
obs=[deriv;deriv1;deriv2;deriv3];
rk=rank(obs);
disp('pour les capteurs 1,2,3 et 4')
if rk==4
    disp('le systme est gnralement observable')
else
    disp(['le systme nest pas observable la dimension de lespace observable est ' num2str(rk)])
end
%dclaration des relations propres au mode I Cas 2
disp('Mode I Cas 2');
qm=qg;
qacpot=A*qa_max/(A+ka);
qac=qacpot;
mu=(qg-qm)*Yoxxg+qac*Yxa;
qo=(qg-qm)*Yog+qm*Yom+qac*Yoa;
qap=0;
qa=qap-qac; 
f=[ -F*X/V+mu*X;
    F*Gin/V-F*G/V-qg*X;
    -F*Co/V+Kla*(Coo-Co)-qo*X;
    -F*A/V+qa*X 
]; 
c=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
h=c*x; 
%observability mesurement
deriv=jacobian(h,x);
Lie1=mtimes(deriv,f);
deriv1=jacobian(Lie1,x);
Lie2=mtimes(deriv1,f);
deriv2=jacobian(Lie2,x);
Lie3=mtimes(deriv2,f);
deriv3=jacobian(Lie3,x); 
obs=[deriv;deriv1;deriv2;deriv3];
rk=rank(obs);
disp('pour les capteurs 1,2,3 et 4')
if rk==4
    disp('le systme est gnralement observable')
else
    disp(['le systme nest pas observable et la dimension de lespace observable est ' num2str(rk)])
end
%dclaration des relations propres au mode I Cas 3
disp('Mode I Cas 3'); 
qm=qmc;
qacpot=A*qa_max/(A+ka);
qac=(qo_max-(qg-qmc)*Yog-qm*Yom)/Yoa;
mu=(qg-qm)*Yoxxg+qac*Yxa;
qo=(qg-qm)*Yog+qm*Yom+qac*Yoa;
qap=0;
qa=qap-qac; 
f=[ -F*X/V+mu*X;
    F*Gin/V-F*G/V-qg*X;
    -F*Co/V+Kla*(Coo-Co)-qo*X;
    -F*A/V+qa*X 
];
c=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
h=c*x; 
%observability mesurement
deriv=jacobian(h,x);
Lie1=mtimes(deriv,f);
deriv1=jacobian(Lie1,x);
Lie2=mtimes(deriv1,f);
deriv2=jacobian(Lie2,x);
Lie3=mtimes(deriv2,f);
deriv3=jacobian(Lie3,x); 
obs=[deriv;deriv1;deriv2;deriv3];
rk=rank(obs);
disp('pour les capteurs 1,2,3 et 4')
if rk==4
    disp('le systme est gnralement observable')
else
    disp(['le systme nest pas observable et la dimension de lespace observable est ' num2str(rk)])
end
%dclaration des relations propres au mode I Cas 4
disp('Mode I Cas 4');
qm=qg;
qacpot=A*qa_max/(A+ka);
qac=(qo_max-(qg-qmc)*Yog-qm*Yom)/Yoa;
mu=(qg-qm)*Yoxxg+qac*Yxa;
qo=(qg-qm)*Yog+qm*Yom+qac*Yoa;
qap=0;
qa=qap-qac; 
f=[ -F*X/V+mu*X;
    F*Gin/V-F*G/V-qg*X;
    -F*Co/V+Kla*(Coo-Co)-qo*X;
    -F*A/V+qa*X 
]; 
c=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
h=c*x; 
%observability mesurement
deriv=jacobian(h,x);
Lie1=mtimes(deriv,f);
deriv1=jacobian(Lie1,x);
Lie2=mtimes(deriv1,f);
deriv2=jacobian(Lie2,x);
Lie3=mtimes(deriv2,f);
deriv3=jacobian(Lie3,x); 
obs=[deriv;deriv1;deriv2;deriv3];
rk=rank(obs);
disp('pour les capteurs 1,2,3 et 4')
if rk==4
    disp('le systme est gnralement observable')
else
    disp(['le systme nest pas observable et la dimension de lespace observable est ' num2str(rk)])
end
%dclaration des relations propres au mode II
disp('Mode II');
mu=(qg_crit-qmc)*Yoxxg+(qg-qg_crit)*Yfexg;
qo=qo_max;
qa=(qg-qg_crit)*Yag; 
f=[ -F*X/V+mu*X;
    F*Gin/V-F*G/V-qg*X;
    -F*Co/V+Kla*(Coo-Co)-qo*X;
    -F*A/V+qa*X 
]; 
c=[1 0 0 0;0 1 0 0;0 0 1 0;0 0 0 1];
h=c*x; 
%observability mesurement
deriv=jacobian(h,x);
Lie1=mtimes(deriv,f);
deriv1=jacobian(Lie1,x);
Lie2=mtimes(deriv1,f);
deriv2=jacobian(Lie2,x);
Lie3=mtimes(deriv2,f);
deriv3=jacobian(Lie3,x); 
obs=[deriv;deriv1;deriv2;deriv3];
rk=rank(obs);
disp('pour les capteurs 1,2,3 et 4')
if rk==4
    disp('le systme est gnralement observable')
else
    disp(['le systme nest pas observable et la dimension de lespace observable est ' num2str(rk)])
end
